using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;


namespace ConsoleApplicationPolygon
{
    //      1  

    /// <summary>
    /// This class simulates a two dimensional point
    /// The point's cooridinates are doubles
    /// <summary/>
    /// <author>   ,   ,  ,  <author/>
    /// <version> 25.9.2007 <version/>
    public class Point
    {
        //Attributes of class:
        private double x;
        private double y;

        //Constructor of class:

        /// <summary>
        /// constructs a new point
        /// <param name="x"> the point's x coordinate <param/>
        /// <param name="y"> the point's y coordinate <param/>
        public Point(double x, double y)
        {
            this.x = x;
            this.y = y;
        }

        // other methods in class:
        /// <summary>
        /// returns the x coordinate.
        /// </summary>
        /// <returns> the x coordinate. </returns>
        public double GetX()
        {
            return this.x;
        }

        /// <summary>
        /// returns the y coordinate.
        /// </summary>
        /// <returns> the y coordinate. </returns>
        public double GetY()
        {
            return this.y;
        }

        /// <summary>
        /// changes the x coordinate to the given value.
        /// </summary>
        /// <param name="x"> the new value for the x coordinate. </param>
        public void SetX(double x)
        {
            this.x = x;
        }

        /// <summary>
        /// changes the y coordinate to the given value.
        /// </summary>
        /// <param name="y"> the new value for the y coordinate. </param>
        public void SetY(double y)
        {
            this.y = y;
        }

        /// <summary>
        /// returns a string that represents the point.
        /// </summary>
        /// <returns> a string that represents the point. </returns>
        public override string ToString()
        {
            return string.Format("({0:F2}, {1:F2})",this.x, this.y );
        }

        //solutions to part B of the Daf Avoda:

        /// <summary>
        /// returns the middle point of this point and a given point
        /// </summary>
        /// <param name="p"> another point so we can find the middle between this 
        /// point and the point p </param>
        /// <returns> the middle point </returns>
        public Point Middle(Point p)
        {
            double middleX = (this.x + p.GetX()) / 2;
            double middleY = (this.y + p.GetY()) / 2;
            return new Point(middleX, middleY);
        }

        /// <summary>
        /// Calculate the distance between this point and a given point
        /// </summary>
        /// <param name="p"> the point we should calculate the distance from </param>
        /// <returns> the distance </returns>
        public double Distance(Point p)
        {
            return (Math.Sqrt((Math.Pow((this.x - p.GetX()), 2) +
                Math.Pow((this.y - p.GetY()), 2))));
        }
        public bool IsEquals(Point p)
        {

            return (p.x == this.x && p.y == this.y);
        }
    }
}
